/* 
   Herman
   (c) 1998 Andrew de Quincey, adq@tardis.ed.ac.uk
   (c) 1998 Thomas Stapleford
   See README.TXT for copying/distribution/modification details.
*/

package herman.misc;


/**
 * Used to hold various global configuration information for the system
 */
public class Configuration
{
  private Configuration(){}


  public static String progName = "Thing!";
  public static String version = "0.1b";
  public static String[] midiDevices;

  
  public static int tensionLevel = 0;

  /**
   * MIDI channel that melody should be played on 
   */
  public static final int MELODYCHANNEL=0;


  /**
   * MIDI channel that accompaniment should be played on 
   */
  public static final int ACCOMPCHANNEL=1;

  /**
   * MIDI channel that percussion should be played on 
   */
  public static final int PERCCHANNEL=2;


  public static int deltaTime = 2000;
}
