/* 
   Herman
   (c) 1998 Andrew de Quincey, adq@tardis.ed.ac.uk
   (c) 1998 Thomas Stapleford
   See README.TXT for copying/distribution/modification details.
*/

package herman.rhythm;
import herman.elements.*;
import java.util.*;

public class Transform
{
  private Transform(){}


  protected static void operate(Phrase p)
  {
    // get the desired transforms
    Enumeration e = p.rhythmStuff.getTransforms();

    // apply each transformation, in turn
    while(e.hasMoreElements())
      ((RhythmTransform) e.nextElement()).apply(p);

    // flush the list of transforms
    p.rhythmStuff.flushTransforms();
  }
}
